#include "stop_watch.h"
#include "watch_state.h"
#include "possible_states.h"
#include "stopped_state.h"
#include "started_state.h"

namespace{

stopped_state stopped_instance;

started_state started_instance;

}

namespace possible_states{

watch_state* stopped = &stopped_instance;

watch_state* started = &started_instance;

}

stop_watch::stop_watch()
  : state(possible_states::stopped)
{
}

void stop_watch::start()
{
  state->start(state);
}

void stop_watch::stop()
{
  state->stop(state);
}

