#include "started_state.h"
#include "stopped_state.h"
#include "watch_access.h"

#include <iostream>

void started_state::stop(watch_access& watch)
{
   std::cout << "started_state received stop() event. Transition to stopped_state\n";
   
   watch.change_state_to<stopped_state>();
}

std::string started_state::state_name() const
{
   return "started_state";
}
