#include "started_state.h"

#include "possible_states.h"
#include "watch_access.h"

#include <iostream>

void started_state::stop(watch_access& watch)
{
   std::cout << "started_state received stop() event. Transition to stopped_state\n";
   
   using possible_states::stopped;
   
   watch.change_state_to(stopped);
}

std::string started_state::state_name() const
{
   return "started_state";
}
