#include "stopped_state.h"

#include "possible_states.h"
#include "watch_access.h"

#include <iostream>

void stopped_state::start(watch_access& watch)
{
   std::cout << "stopped_state received start() event. Transition to started_state\n";
   
   using possible_states::started;
   
   watch.change_state_to(started);
}

std::string stopped_state::state_name() const
{
   return "stopped_state";
}


